//Version 0.1 (17/03/2018):
// port TCP/IP by default: 50001 instead 3020
//Version 0 (25/01/2017):
// * original issue}

//pour crer une application, cliquez sur Nouveau puis Application, "Enregistrer
//sous" sous la forme "Form_Client.cpp" dans le rpertoire souhait puis "Enregistrer
//le projet sous" sous la forme "Client.bpr". Sortir puis revenir pour contrler.
//inclure #include <systdate.h>

//---------------------------------------------------------------------------

#include <vcl.h>
#include <systdate.h>
#pragma hdrstop

#include "Form_Client.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ConnectionClick(TObject *Sender)
{
 String time; time=Time();
 Memo_Log->Lines->Add(time+": "+"Connexion asked");
 ClientSocket1->Open();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::DisconnectionClick(TObject *Sender)
{
 String time; time=Time();
 Memo_Log->Lines->Add(time+": "+"Disconnexion asked");
 //Close the socket connexion
 ClientSocket1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Connect(TObject *Sender,
      TCustomWinSocket *Socket)
{
 String time; time=Time();
 //This message specifies that the client is connected to the server
 Memo_Log->Lines->Add(time+": "+"Connected to "+Socket->RemoteHost);
 Form1->Connection->Down=TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Connecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
 String time; time=Time();
 //This message specifies that the server is being searched by the client
 Memo_Log->Lines->Add(time+": "+"The server is being searched");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Disconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
 String time; time=Time();
 //This message specifies that the client is going to disconnect from the server}
 Memo_Log->Lines->Add(time+": "+"Disconnected");
 Form1->Disconnection->Down=TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Error(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
 String ErrorMsg;
 String time; time=Time();
 ErrorMsg=IntToStr(ErrorCode);
 Memo_Log->Lines->Add(time+": "+"  Error: "+ErrorMsg);
 //The error is managed
 ErrorCode = 0;
 Form1->Disconnection->Down=TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
 String RECEIVED;
 String time; time=Time();
 RECEIVED=Socket->ReceiveText();
 Memo_Reception_Text->Text=Memo_Reception_Text->Text+time+": "+RECEIVED+char(13)+char(10);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
 Memo_Reception_Text->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TRANSMISSION_TCP_IP_COMMAND(String COMMAND)
{
 String time; time=Time();
 //to the Multipsk server
 Form1->ClientSocket1->Socket->SendText(COMMAND);
 //display the command
 Form1->Memo_reception_commands->Lines->Add(time+" Command: "+COMMAND);
}

void __fastcall TForm1::Manual_commandClick(TObject *Sender)
{
 String COMMAND;
 COMMAND=Edit1->Text;
 TRANSMISSION_TCP_IP_COMMAND(COMMAND);
}
//---------------------------------------------------------------------------

